// OA99_PLUS_DEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "D5ScannerS78Demo.h"
#include "D5ScannerS78DemoDlg.h"
#include "D5ScannerS78.h"
#include "D5Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WORD getLum (BYTE *pImage)
{
	int cnt = 0;
	BYTE *p;
	long lLum = 0;
	int i, j;
	for (i = 192 / 8; i < 192 * 7 / 8; i++)
	{
		p = pImage + 192 * i + 192 / 8;
		for (j = 192 / 8; j < 192 * 7 / 8; j++)
		{
			lLum += *p++;
			cnt ++;
		}
	}
	lLum /= cnt;
	lLum = min (lLum, 255);
	return (WORD)lLum;
}

//////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD5ScannerS78DemoDlg dialog

CD5ScannerS78DemoDlg::CD5ScannerS78DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD5ScannerS78DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD5ScannerS78DemoDlg)
	m_strFeaPath = _T("");
	m_strMatchResult = _T("");
	m_strMatchTime = _T("");
	m_strMatchNResult = _T("");
	m_strMatchCnt = _T("");
	m_strStatus = _T("");
	m_nLum = 0;
	m_strMark1 = _T("");
	m_strMark2 = _T("");
	m_bContinuous = FALSE;
	m_strFeaLoadPath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CD5ScannerS78DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD5ScannerS78DemoDlg)
	DDX_Control(pDX, IDC_BTN_CLOSE_DEV, m_btnCloseDev);
	DDX_Control(pDX, IDC_BTN_CHECK_MARK, m_btnCheckMark);
	DDX_Control(pDX, IDC_BTN_SET_MARK, m_btnSetMark);
	DDX_Control(pDX, IDC_BTN_OPEN_DEV, m_btnOpenDev);
	DDX_Control(pDX, IDC_COMBO1, m_comboType);
	DDX_Control(pDX, IDC_BTN_IMAGE, m_btnImage);
	DDX_Text(pDX, IDC_EDIT_FEA_PATH, m_strFeaPath);
	DDX_Text(pDX, IDC_EDIT_MATCH_RESULT, m_strMatchResult);
	DDX_Text(pDX, IDC_EDIT_MATCH_TIME, m_strMatchTime);
	DDX_Text(pDX, IDC_EDIT_MATCHN_RESULT, m_strMatchNResult);
	DDX_Text(pDX, IDC_EDIT_MATCH_CNT, m_strMatchCnt);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_EDIT_LUM, m_nLum);
	DDX_Text(pDX, IDC_EDIT_MARK1, m_strMark1);
	DDX_Text(pDX, IDC_EDIT_MARK2, m_strMark2);
	DDX_Check(pDX, IDC_CHECK_CONTINUOUS, m_bContinuous);
	DDX_Text(pDX, IDC_EDIT_FEALOAD_PATH, m_strFeaLoadPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD5ScannerS78DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CD5ScannerS78DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN_DEV, OnBtnOpenDev)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BTN_BROWSE, OnBtnBrowse)
	ON_BN_CLICKED(IDC_BTN_MATCH, OnBtnMatch)
	ON_BN_CLICKED(IDC_BTN_MATCHN, OnBtnMatchn)
	ON_BN_CLICKED(IDC_BTN_ENUM_DEV, OnBtnEnumDev)
	ON_BN_CLICKED(IDC_BTN_SAVE_IMG, OnBtnSaveImg)
	ON_BN_CLICKED(IDC_BTN_SAVE_FEA, OnBtnSaveFea)
	ON_BN_CLICKED(IDC_BTN_SET_MARK, OnBtnSetMark)
	ON_BN_CLICKED(IDC_BTN_CHECK_MARK, OnBtnCheckMark)
	ON_BN_CLICKED(IDC_BTN_LOAD_FEA, OnBtnLoadFea)
	ON_BN_CLICKED(IDC_BTN_CLOSE_DEV, OnBtnClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD5ScannerS78DemoDlg message handlers

BOOL CD5ScannerS78DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	memset (gpImageCap, 0xFF, 192 * 192);
	m_bContinuous = FALSE;
	UpdateData (false);

	m_btnImage.m_dwWidth  = 192;
	m_btnImage.m_dwHeight = 192;
	m_btnImage.m_pImage = gpImageCap;
	m_btnImage.SetHuePalate();
	m_btnImage.Invalidate ();	

	gbProcessTending = FALSE;

	m_btnSetMark.EnableWindow (FALSE);
	m_btnCheckMark.EnableWindow (FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CD5ScannerS78DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CD5ScannerS78DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CD5ScannerS78DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CD5ScannerS78DemoDlg::OnBtnOpenDev() 
{
	long  lRet;

	lRet = D5OpenDevice (m_comboType.GetCurSel());

	if (lRet == 0)
	{
		m_strStatus = "Open Device OK";

		m_btnOpenDev.EnableWindow (false);
		m_btnCloseDev.EnableWindow (true);
		m_btnSetMark.EnableWindow (true);
		m_btnCheckMark.EnableWindow (true);
		
		SetTimer (1, 100, NULL);
	}
	else
	{
		m_strStatus = "Open Device Fail";

		m_btnSetMark.EnableWindow (false);
		m_btnCheckMark.EnableWindow (false);
	}	

	UpdateData (false);
}

void CD5ScannerS78DemoDlg::OnTimer(UINT nIDEvent) 
{
	static bool bFingerOn = FALSE;
	static WORD uCircle = 0;
	bool   bFP;

	UpdateData (true);	

	D5GetImage (m_comboType.GetCurSel(), gpImage);

	if (m_bContinuous)
	{
		memcpy (gpImageCap, gpImage, 192 * 192);
	}
	else
	{
		bFP = D5CheckFP (gpImage);
				
		if (bFP)
		{
			if (!bFingerOn)
			{
				uCircle ++;
				if (uCircle >= 2)
				{
					bFingerOn = TRUE;

					D5Beep (m_comboType.GetCurSel(), 40);
					Sleep (100);

					memcpy (gpImageCap, gpImage, 192 * 192);					
					
					gbProcessTending = TRUE;
					OnBtnMatchn ();
				}
			}
		}
		else
		{
			bFingerOn = FALSE;
			uCircle = 0;
		}
	}

	m_nLum = getLum (gpImageCap);
	UpdateData (false);			

	m_btnImage.m_dwWidth  = 192;
	m_btnImage.m_dwHeight = 192;
	m_btnImage.m_pImage = gpImageCap;
	m_btnImage.SetHuePalate();
	m_btnImage.Invalidate ();	
	
	CDialog::OnTimer(nIDEvent);
}

void CD5ScannerS78DemoDlg::OnClose() 
{
	D5CloseDevice (m_comboType.GetCurSel());
	
	CDialog::OnClose();
}

int CD5ScannerS78DemoDlg::LoadFeature(char *strFile, BYTE *pFeature)
{
	CFile f;

	//ֵ
	if (f.Open (strFile, CFile::modeRead) == NULL)
	{
		MessageBox ("File open error!");
		return -1;
	}
	f.Read (pFeature, 256);
	f.Close ();

	return 0;
}

void CD5ScannerS78DemoDlg::OnBtnBrowse() 
{
	CFileDialog fDlg(true, "fea", "",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"Feature files (*.fea)|*.fea|");
	short result;
	
	if (fDlg.DoModal() != IDOK)
	{
		return;		
	}

	m_strFeaPath = fDlg.GetPathName();
	UpdateData (FALSE);

	result = LoadFeature (m_strFeaPath.GetBuffer(200), gpFeature2);
	if (result == -1)
	{
		MessageBox ("Invalid Feature File!");
	}	
}

void CD5ScannerS78DemoDlg::OnBtnMatch() 
{
	long result;
	int i;

	if (gbProcessTending) D5Process (gpImageCap, gpFeature);

	result = D5Match (gpFeature, gpFeature2, 180, 5);
	if (result == 0)
	{
		m_strMatchResult = "OK";

		D5CloseLED (m_comboType.GetCurSel(), LED_B);		
		D5OpenLED (m_comboType.GetCurSel(), LED_G);
		for (i = 0; i < 3; i++)
		{
			D5Beep (m_comboType.GetCurSel(), 40);
			Sleep (40);
		}
		D5CloseLED (m_comboType.GetCurSel(), LED_G);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);		
	}
	else
	{
		m_strMatchResult = "FAIL";

		D5CloseLED (m_comboType.GetCurSel(), LED_B);		
		D5OpenLED (m_comboType.GetCurSel(), LED_R);
		D5Beep (m_comboType.GetCurSel(), 160);
		D5CloseLED (m_comboType.GetCurSel(), LED_R);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);		
	}
	UpdateData (false);	
}

char gpFileName[1000][256];
BYTE gpFeaBuf[1000][256];

void CD5ScannerS78DemoDlg::OnBtnMatchn() 
{
	char pDirName[200];
	char pPathName[200];
	HANDLE hSearch;
	bool bSearch;
	long result;
	WIN32_FIND_DATA fd;
	DWORD tMatch;
	int  uFeaCnt;
	int  i;

	if (gbProcessTending) D5Process (gpImageCap, gpFeature);

	GetModuleFileName (NULL, pDirName, 200);
	for (i = strlen (pDirName) - 1; i >= 0; i --)
	{
		if (pDirName[i] == '\\') break;
	}
	pDirName[i + 1] = 0;

	strcpy (pPathName, pDirName);
	strcat (pPathName, "*.fea");
	
	uFeaCnt = 0;
	hSearch = FindFirstFile (pPathName, &fd);
	if ((DWORD)hSearch != 0xFFFFFFFF)
	{
		while (1)
		{
			if (uFeaCnt <= 1000)
			{
				strcpy (pPathName, pDirName);
				strcat (pPathName, fd.cFileName);
				strcpy (gpFileName[uFeaCnt], fd.cFileName);
				result = LoadFeature (pPathName, gpFeaBuf[uFeaCnt]);		
				if (result == -1)
				{
					MessageBox ("Invalid Feature File!");
					return;
				}
				uFeaCnt ++;
			}
			bSearch = FindNextFile (hSearch, &fd);
			if (!bSearch) break;
		}
	}

	tMatch = GetTickCount ();
	result = D5MatchN (gpFeature, gpFeaBuf, uFeaCnt, 180, 5);
	tMatch = GetTickCount () - tMatch;

	if (result >= 0) 
	{
		strcpy (m_strMatchNResult.GetBuffer(100), gpFileName[result]);
		strcat (m_strMatchNResult.GetBuffer(100), " OK");

		D5CloseLED (m_comboType.GetCurSel(), LED_B);
		D5OpenLED (m_comboType.GetCurSel(), LED_G);
		for (i = 0; i < 3; i++)
		{
			D5Beep (m_comboType.GetCurSel(), 40);
			Sleep (40);
		}
		D5CloseLED (m_comboType.GetCurSel(), LED_G);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);
		
	}
	else 
	{
		strcpy (m_strMatchNResult.GetBuffer(100), "All FAIL");

		D5CloseLED (m_comboType.GetCurSel(), LED_B);		
		D5OpenLED (m_comboType.GetCurSel(), LED_R);
		D5Beep (m_comboType.GetCurSel(), 160);
		D5CloseLED (m_comboType.GetCurSel(), LED_R);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);		
	}
	itoa (uFeaCnt, m_strMatchCnt.GetBuffer(100), 10);
	itoa (tMatch, m_strMatchTime.GetBuffer(100), 10);
	UpdateData (false);	
}

void CD5ScannerS78DemoDlg::OnBtnEnumDev() 
{
	char pName[8][128];
	short iNum;
	int  i;

	m_comboType.ResetContent();
	
	iNum = D5EnumDevice (pName);

	for (i = 0; i < iNum; i++)
	{
		m_comboType.AddString (pName[i]);
	}
	m_comboType.SetCurSel (0);

	m_strStatus = "";
	UpdateData (false);

	if (iNum >= 1) m_btnOpenDev.EnableWindow (true);
			  else m_btnOpenDev.EnableWindow (false);
	m_btnCloseDev.EnableWindow (false);
}

void CD5ScannerS78DemoDlg::OnBtnSaveImg() 
{
	CFileDialog fDlg(false, "bmp", "",
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"Bmp files (*.bmp)|*.bmp|");

	if (fDlg.DoModal () != IDOK) return;

	D5SaveBMPFile (fDlg.GetPathName().GetBuffer (200), gpImageCap);
}

void CD5ScannerS78DemoDlg::OnBtnSaveFea() 
{
	CFileDialog fDlg(false, "fea","",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"template files (*.fea)|*.fea|");
	unsigned char pBuffer[500];
	CFile f;
	WORD uLen;	
	
	if (fDlg.DoModal () != IDOK) return;
	if (f.Open (fDlg.GetPathName(), CFile::modeCreate | CFile::modeWrite) == NULL)
	{
		MessageBox ("File open error!");
		return;
	}

	f.Write (gpFeature, 256);
	f.Close ();	
}

void CD5ScannerS78DemoDlg::OnBtnSetMark() 
{
	BYTE  pMark[8];
	BYTE  uByte;
	long  lRet;
	int   i;

	UpdateData (true);

	if (m_strMark1.GetLength() != 16) 
	{
		MessageBox ("8 Bytes Required");
		return;
	}

	for (i = 0; i < 8; i++)
	{
		uByte = m_strMark1.GetAt (2 * i);
		pMark[i] = uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
		pMark[i] <<= 4;
		uByte = m_strMark1.GetAt (2 * i + 1);
		pMark[i] += uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
	}

	lRet = D5SetMark (m_comboType.GetCurSel(), pMark);

	if (lRet == 0)
	{
		MessageBox ("Set Mark OK");
	}
	else
	{
		MessageBox ("Set Mark Fail");
	}	
}

void CD5ScannerS78DemoDlg::OnBtnCheckMark() 
{
	BYTE  pMark[8];
	BYTE  uByte;
	long  lRet;
	int   i;

	UpdateData (true);

	if (m_strMark2.GetLength() != 16) 
	{
		MessageBox ("8 Bytes Required");
		return;
	}

	for (i = 0; i < 8; i++)
	{
		uByte = m_strMark2.GetAt (2 * i);
		pMark[i] = uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
		pMark[i] <<= 4;
		uByte = m_strMark2.GetAt (2 * i + 1);
		pMark[i] += uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
	}

	lRet = D5CheckMark (m_comboType.GetCurSel(), pMark);

	if (lRet == 0)
	{
		MessageBox ("Check Mark OK");
	}
	else
	{
		MessageBox ("Check Mark Fail");
	}
}

void CD5ScannerS78DemoDlg::OnBtnLoadFea() 
{
	CFileDialog fDlg(true, "fea", "",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"Feature files (*.fea)|*.fea|");
	short result;
	
	if (fDlg.DoModal() != IDOK)
	{
		return;		
	}

	m_strFeaLoadPath = fDlg.GetPathName();
	UpdateData (FALSE);

	result = LoadFeature (m_strFeaLoadPath.GetBuffer(200), gpFeature);
	if (result == -1)
	{
		MessageBox ("Invalid Feature File!");
	}
	
	gbProcessTending = FALSE;
}

void CD5ScannerS78DemoDlg::OnBtnClose() 
{
	long  lRet;

	lRet = D5CloseDevice (m_comboType.GetCurSel());
	
	if (lRet == 0)
	{
		m_strStatus = "Close Device OK";

		m_btnOpenDev.EnableWindow (true);
		m_btnCloseDev.EnableWindow (false);
		m_btnSetMark.EnableWindow (false);
		m_btnCheckMark.EnableWindow (false);
	}
	else
	{
		m_strStatus = "Close Device Fail";
	}

	UpdateData (false);
}
